//----------------------------------------------------------------
/* SURVIVAL
/* programed by M.I.,Aug.21'90
/* Oh!X 1992-1
// V3.20以降専用
//----------------------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
width(0)
tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------

int jj,b1,b2,b3,b4,bb,kiri,ms,f=0,rd=1
dim int cc(51),c(3,8),pp(51),p(3,8),stc(15),stp(15)
dim int b(3),sute(3),m(3),kei(3),ten(4,3)
dim str nam(3)={"太郎","次郎","花子","貴方"}
dim str nams(3)
dim str suit(3)={"スペード","ハート","ダイア","クラブ"}

if not isLocalizeJapan() then {
	nam ={"Taro","Jiro","Hana","You "}
	nams={"Taro's","Jiro's","Hana's","Your"}
	suit={"Spade","Heart","Dia","Club"}
}

// 音声データ読み込み
dim int snd(8)
int i
for i=1 to 8
	snd(i)=-1
//	gLocate(0,35+i)
//	print "survival"+str$(i)+".mp3";
	if i=2 then continue:// 1<-1+2なので2はない
	snd(i)=a_setPlayData("survival"+str$(i)+".mp3")
//	print "/";snd(i)
next

setgPalet16X68(1,&h000000ff):// palet(1,0)

/* main program
while f=0
	scrn()
	play()
	jd3()
endwhile
owari()

// 音声バッファー開放
for i=1 to 8
	if snd(i)<0 then continue
	a_end(snd(i))
next

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()
end

//----------------------------------------------------------------
/* make screen
//----------------------------------------------------------------

func scrn()
int i
	apage(GPAGE3):vpageX68(15)
	fill16X68(0,0,511,511,10)
	apage(GPAGE2)
	box16X68(0,0,511,511,15)
	box16X68(1,1,510,510,15)
	line16X68(  2, 80,159, 80,15)
	line16X68(161,144,509,144,15)
	line16X68(161,352,391,352,15)
	line16X68(160,  2,160,383,15)
	line16X68(320,  2,320,143,15)
	line16X68(  2,384,391,384,15)
	line16X68(392,145,392,509,15)
	line16X68(393,320,509,320,15)
	for i=0 to 4:line16X68(     321,i*24+24,     509,i*24+24,15):next
	for i=0 to 5:line16X68(i*30+360,     25,i*30+360,    143,15):next
	symbol16X68(18,19,"SURVIVAL"	,2, 1,FONT,FNTSZ)
	symbol16X68(16,17,"SURVIVAL"	,2,15,FONT,FNTSZ)
	symbol16X68(380,4,"ＳＣＯＲＥ"	,1,15,FONT,FNTSZ)
	for i=0 to 3:symbol16X68(     324,i*24+53,nam(i) ,1,15,FONT,FNTSZ):next
	for i=1 to 4:symbol16X68(i*30+341,     29,str$(i),1,15,FONT,FNTSZ):next
	if isLocalizeJapan() then {
		symbol16X68(481,29,"合計",0.8,15,FONT,FNTSZ)
	} else {
		symbol16X68(481,31,"Total",0.7,15,FONT,FNTSZ)
	}
	for i=0 to 3:kei(i)=0:next
endfunc

//----------------------------------------------------------------
/* play
//----------------------------------------------------------------

func play()
	while rd<5
		prep()
		splay()
		jd2()
	endwhile
	cwait(60)
endfunc

//----------------------------------------------------------------
/* 準備作業

func prep()
int i,j,a,b,s
	/* music data set
	/* deal
	apage(GPAGE1)
	fill16X68((rd-1)*30+331,25,(rd-1)*30+359,47,0)
	fill16X68( rd   *30+331,25, rd   *30+359,47,5)
	for i=1 to 4:symbol16X68(i*30+341,29,str$(i),1,15,FONT,FNTSZ):next
	if rd=1 then {
		s=sel(localizedString("ルールの説明","Description of the rule"),1,1)
		if s=1 then rule()
	}
	randomize(val(mid$(time$,4,2)+right$(time$,2)))
	for i=0 to 51:cc(i)=i+1:next
	ms=16:for i=0 to 3:m(i)=9:next
	if s=2 or rd>1 then {
		er_upms()
		if isLocalizeJapan() then {
			symbol16X68(200,24,"シャッフル"		,1,15,FONT,FNTSZ)
			symbol16X68(224,56,"及び"			,1,15,FONT,FNTSZ)
			symbol16X68(200,88,"カード配布"		,1,15,FONT,FNTSZ)
		} else{
			symbol16X68(200,24,"Shuffle"		,1,15,FONT,FNTSZ)
			symbol16X68(224,56," and"			,1,15,FONT,FNTSZ)
			symbol16X68(200,88,"deal cards"	,1,15,FONT,FNTSZ)
		}
	}
	int k
	for i=0 to 99
		a=int(rnd()*52)
		b=int(rnd()*52)
		k=cc(a):cc(a)=cc(b):cc(b)=k
	next
	for i=0 to 51         /* Aを最高位にする
		if cc(i)=1  then pp(i)=13:continue
		if cc(i)=14 then pp(i)=26:continue
		if cc(i)=27 then pp(i)=39:continue
		if cc(i)=40 then pp(i)=52:continue
		pp(i)=cc(i)-1
	next
	for i=0 to 8
		c(0,i)=cc(i   ):p(0,i)=pp(i   )
		c(1,i)=cc(i+9 ):p(1,i)=pp(i+ 9)
		c(2,i)=cc(i+18):p(2,i)=pp(i+18)
		c(3,i)=cc(i+27):p(3,i)=pp(i+27)
	next
	for i=0 to 15
		stc(i)=cc(i+36):stp(i)=pp(i+36)
	next
	for i=0 to 51:cc(i)=0:pp(i)=0:next
	er_upms()
	if s=1 then {
		click()
		apage(GPAGE0):fill16X68(0,0,511,511,0):apage(GPAGE1)
	}
	mkba()
	for j=0 to 2:comcd(j):next
	plcd():stcd()
	kiri=(c(3,8)-1)\13:/* 切り札の決定
	if isLocalizeJapan() then {
		symbol16X68(212,360,"切り札は"+suit(kiri),1,15,FONT,FNTSZ)
	} else {
		symbol16X68(212-8*4,360,"Master card is "+suit(kiri),1,15,FONT,FNTSZ)
	}
	a_play(snd(6))
	for j=0 to 3:for i=0 to 8
		if (p(j,i)-1)\13=kiri then p(j,i)=p(j,i)+100
	next:next
	for i=0 to 15
		if (stp(i)-1)\13=kiri then stp(i)=stp(i)+100
	next
	for j=0 to 2:jun(j):next
	if rd=1 then jj=0
	symbol16X68(196,174,nam(jj)+localizedString("が最初"," is first"),1.5,1,FONT,FNTSZ)
	a_play(snd(5))
	click()
endfunc

//----------------------------------------------------------------
/* 各トリップごとのプレー及び判定

func splay()
	repeat
		b1=0:b2=0:b3=0:b4=0:bb=1
		ssplay()
		jd1()
	until m(0)+m(1)+m(2)=0 or m(1)+m(2)+m(3)=0 or m(2)+m(3)+m(0)=0 or m(3)+m(0)+m(1)=0
endfunc

//----------------------------------------------------------------

func ssplay()
	while bb<5
		if jj>=0 and jj<=2 then {
			if bb=1 then { /* bbは場に出す順
				b1=first():bb=2:jj=jj+1
				if jj=3 then you():jj=0:bb=3:continue
			} else if bb=2 then {
				b2=com(2):bb=3:jj=jj+1
				if jj=3 then you():jj=0:bb=4:continue
			} else if bb=3 then {
				b3=com(3):bb=4:jj=jj+1
				if jj=3 then you():bb=5
			} else if bb=4 then b4=com(4):bb=5
		} else if jj=3 and bb=1 then you():jj=0:bb=2:continue
	endwhile
endfunc

//----------------------------------------------------------------
/* com play as 1st player

func first()
int a,i,j,id,is,bc=0
	if m(jj)>0 then { /* 手札がなければ飛ばす
		dsban(jj)
		if sute(jj)>0 then { /* 前回勝った札があれば出してみる
			if sute(jj)>100 then a=(sute(jj)-101)\13 else {
				a=(sute(jj)-1)\13
			}
			for i=0 to m(jj)-1
				j=m(jj)-1-i
				if (c(jj,j)-1)\13=a then bc=1:break
			next
		}
		if bc=0 then {
			for i=0 to m(jj)-1    /* 強い切り札があれば出す
				if p(jj,i)-101 mod 13>8 then bc=1:break
			next
		}
		if bc=0 then { /*強い札があれば出す
			for i=0 to m(jj)-1
				if (p(jj,i)-1) mod 13>7 then bc=1:break
			next
		}
		if bc=0 then i=int(rnd()*m(jj))
		is=i:m(jj)=m(jj)-1
		bacd(jj,is)
		comcd(jj)
		id=p(jj,is):b(jj)=id:sute(jj)=id
		p(jj,is)=0:c(jj,is)=0
		for i=0 to 8:cc(i)=c(jj,i):pp(i)=p(jj,i):next
		cdleft(is)
		for i=0 to 8:c(jj,i)=cc(i):p(jj,i)=pp(i):next
		if jj=2 then cwait(15) else cwait(30)
		return(id)
	}
	b(jj)=0
	return(0)
endfunc

//----------------------------------------------------------------
/* from play as 2nd to 4th player

func com(q)
int i,j,id,is,a,ap=0,sup=0
	if b1>100 then a=(b1-101)\13 else if b1>0 then a=(b1-1)\13
	if m(jj)>0 then {		/*手札がなければ飛ばす
		dsban(jj)
		cwait(30)
		for i=0 to m(jj)-1	/*最初の人と同じ札があるか
			if (c(jj,i)-1)\13=a then ap=ap+1
		next
		if ap=0 then {			/* ない場合
			if b1>100 then {	/* 切り札が出ている場合
				is=weakest(jj)
			} else {				/* 切り札が出てない場合
				for i=0 to m(jj)-1
					if p(jj,i)>100 then sup=sup+1
				next
				if sup>0 then {
					switch q
						case 2:is=scom2():break
						case 3:is=scom3():break
						case 4:is=scom4()
					endswitch
				} else is=weakest(jj)
			}
		} else { /* 最初の人と同じ札がある場合
			switch q
				case 2:is=sscom2():break
				case 3:is=sscom3():break
				case 4:is=sscom4()
			endswitch
		}
		m(jj)=m(jj)-1
		bacd(jj,is)
		comcd(jj)
		id=p(jj,is):sute(jj)=id
		if p(jj,is)<100 and ap=0 then id=0
		b(jj)=id:p(jj,is)=0:c(jj,is)=0
		for i=0 to 8:cc(i)=c(jj,i):pp(i)=p(jj,i):next
		cdleft(is)
		for i=0 to 8:c(jj,i)=cc(i):p(jj,i)=pp(i):next
		if jj=2 then cwait(15) else cwait(30)
		return(id)
	}
	b(jj)=0
	return(0)
endfunc

//----------------------------------------------------------------
/* play you

func you()
int i,is,x,y,l,r,a,ap=0,bc=0
	if m(3)>0 then { /* 手札がなければ飛ばす
		dsban(3)
		if bb=1 then fill16X68(161,208,391,312,0)
		if b1>100 then a=(b1-101)\13 else if b1>0 then a=(b1-1)\13
		if b1>0 then {
			for i=0 to m(3)-1
				if (c(3,i)-1)\13=a then ap=ap+1
			next
		}
		while bc=0
			if isLocalizeJapan() then {
			symbol16X68(176,48,"出したいカードを"	,1,15,FONT,FNTSZ)
			symbol16X68(208,84,"タップ"				,1,15,FONT,FNTSZ)
			} else {
			symbol16X68(176,48,"Tap your"			,1,15,FONT,FNTSZ)
			symbol16X68(176,84,"  selected card"	,1,15,FONT,FNTSZ)
			}

			while getTouchStatus()=TOUCH_NONE
			endwhile

			dim float tpoint(1)
			int touchCnt=getTouchPoint(tpoint)
			x=tpoint(0)
			y=tpoint(1)

			er_upms()
			if m(3)>6 then is=(x-48)\36
			if m(3)<7 then is=(x-48)\58
			if is>m(3)-1 then {
				dame():cwait(40):er_upms():continue
			}
			if b1>0 and ap>0 and (c(3,is)-1)\13<>a then {
				dame():cwait(40):er_upms():continue
			} else {
				bacd(3,is)
				b(3)=p(3,is)
				sute(3)=b(3)
				bc=1
			}
		endwhile
		if b1>0 and ap=0 and p(3,is)<100 then b(3)=0
		switch bb
			case 1:b1=b(3):break
			case 2:b2=b(3):break
			case 3:b3=b(3):break
			case 4:b4=b(3)
		endswitch
		p(3,is)=0
		c(3,is)=0
		m(3)=m(3)-1
		for i=0 to 8:cc(i)=c(3,i):pp(i)=p(3,i):next
		cdleft(is)
		for i=0 to 8:c(3,i)=cc(i):p(3,i)=pp(i):next
		fill16X68(2,385,391,509,0)
		plcd()
	} else b(3)=0
endfunc

//----------------------------------------------------------------
/* 各トリックごとの判定

func jd1()
int i,j,a
dim int ba(3)
	for i=0 to 3:ba(i)=b(i):next
	a_play(snd(5))
	for i=0 to 2
		for j=i+1 to 3
			if b(i)<b(j) then a=b(i):b(i)=b(j):b(j)=a
		next
	next
	for j=0 to 3
		if b(0)=ba(j) then kachi(j):a_play(snd(5)):cwait(60):break
	next
	jj=j
	er_ms()
	m(jj)=m(jj)+1
	if ms>0 then {
		if isLocalizeJapan() then {
			symbol16X68(204,175,nam(jj)+"が1枚取ります",1,1,FONT,FNTSZ)
		} else {
			symbol16X68(204,175,nam(jj)+" get a card.",1,1,FONT,FNTSZ)
		}
		cwait(20)
		c(jj,m(jj)-1)=stc(ms-1):p(jj,m(jj)-1)=stp(ms-1):ms=ms-1
		if jj<3 then pluscom(jj,m(jj)):jun(jj) else plcd()
		decst(ms)
	}
	fill16X68(161,208,391,312,0)
	sutecd()
	cwait(40)
endfunc

//----------------------------------------------------------------
/* 各ラウンドごとの判定

func jd2()
int i,s
	a_play(snd(4))
	symbol16X68(182,224,nam(jj)+" "+str$(m(jj))+localizedString("枚残り"," left"),2,5,FONT,FNTSZ)
	ten(rd,jj)=m(jj)*100
	apage(GPAGE2)
	symbol16X68(		  rd*30+338,jj*24+48+4,str$(ten(rd,jj)),0.9,15,FONT,FNTSZ)
	for i=0 to 3
		if m(i)=0 then {
			ten(rd,i)=0
			symbol16X68(rd*30+350,i *24+48+4,str$(ten(rd,i )),0.9,15,FONT,FNTSZ)
		}
	next
	for i=0 to 3
		kei(i)=kei(i)+ten(rd,i)
		fill16X68(481,i*24+48+1,509,i*24+71-1,10)
		if kei(i)<100 then {
			symbol16X68(500,i*24+48+4,str$(kei(i)),0.9,15,FONT,FNTSZ)
		} else {
			symbol16X68(488,i*24+48+4,str$(kei(i)),0.9,15,FONT,FNTSZ)
		}
	next
	apage(GPAGE1)
	rd=rd+1
	if rd<5 then {
		s=sel(localizedString(str$(rd)+"回目を始めます","Start next time."),2,2)
		if s=2 then f=1:rd=5 else er_upms()
	} else rd=5
	apage(GPAGE1):fill16X68(0,  0,511,511,0)
	apage(GPAGE0):fill16X68(0,144,511,511,0)
	apage(GPAGE1)
endfunc
/* 最終判定
func jd3()
int i,j,a,b,s
	if f=0 then { /* 途中でやめた場合表示しない
		vpageX68(9)
		apage(GPAGE0):fill16X68(0,0,511,511,0)
		for i=0 to 5
			box16X68(48+i*6,80+i*6,464-i*6,432-i*6,15)
		next
		fill16X68(79,111,433,401,2)
		kei(3)=kei(3)+1
		for i=0 to 3:cc(i)=kei(i):next
		for i=0 to 2
		for j=i+1 to 3
			if cc(i)<=cc(j) then {
				a=cc(i):cc(i)=cc(j):cc(j)=a
			}
			next
		next
		for i=0 to 3
			if cc(0)=kei(i) then jj=i:break
		next
		symbol16X68(97,218,nam(jj)+localizedString("の 勝ち!"," win!"),2,5,FONT,FNTSZ)
		a_play(snd(7))
		s=sel(localizedString("もう一度やりますか？","Try again?"),2,2)
		if s=1 then {
		    rd=1		 :fill16X68(0,0,511,511,0)
			apage(GPAGE1):fill16X68(0,0,511,511,0)
			apage(GPAGE2):fill16X68(0,0,511,511,0)
			vpageX68(15)
		} else f=1
	}
endfunc

//----------------------------------------------------------------
/* 終了後の表示

func owari()
	vpageX68(2):apage(GPAGE1)
	fill16X68(0,0,511,511,2)
	symbol16X68(252,400,localizedString("お疲れ様でした","See you again."),2,15,FONT,FNTSZ)
	a_play(snd(8))
endfunc

//----------------------------------------------------------------
/* 最弱の札を見つける

func weakest(jj)
int i,j,a,is
dim int p1(8)
	for i=0 to m(jj)-1
		if p(jj,i)<100 then p1(i)=p(jj,i)-1 mod 13 else {
			p1(i)=(p(jj,i)-101 mod 13)+100
		}
	next
	for i=0 to m(jj)-2
		for j=i+1 to m(jj)-1
			if p1(i)>p1(j) and p1(j)>0 then {
				a=p1(i):p1(i)=p1(j):p1(j)=a
			}
		next
	next
	for i=0 to m(jj)-1
		if p1(0)<100 then {
			if p(jj,i)-1 mod 13=p1(0) then is=i:break
		} else {
			if (p(jj,i)-101 mod 13)+100=p1(0) then is=i:break
		}
	next
	return(is)
endfunc

//----------------------------------------------------------------
/* comカードを強さで並び替え

func jun(k)
int i,ii,a
	for i=0 to 7
		for ii=i+1 to 8
			if p(k,i)>p(k,ii) and p(k,ii)>0 then {
				a=p(k,i):p(k,i)=p(k,ii):p(k,ii)=a
				a=c(k,i):c(k,i)=c(k,ii):c(k,ii)=a
			}
		next
	next
endfunc

//----------------------------------------------------------------

func scom2()
int i,is,bc=0
	for i=0 to m(jj)-1
		if p(jj,i)>100 then is=i:bc=1:break
	next
	if bc=0 then is=weakest(jj)
	return(is)
endfunc

//----------------------------------------------------------------

func scom3()
int i,is,bc=0
	for i=0 to m(jj)-1
		if p(jj,i)>b2 then is=i:bc=1:break
	next
	if bc=0 then is=weakest(jj)
	return(is)
endfunc

//----------------------------------------------------------------

func scom4()
int i,is,bc=0
	for i=0 to m(jj)-1
		if p(jj,i)>b2 and p(jj,i)>b3 then is=i:bc=1:break
	next
	if bc=0 then is=weakest(jj)
	return(is)
endfunc

//----------------------------------------------------------------

func sscom2()
int i,is,a,bc=0
	if b1>100 then a=(b1-101)\13 else if b1>0 then a=(b1-1)\13
	for i=0 to m(jj)-1
		if (c(jj,i)-1)\13=a and p(jj,i)>b1 then is=i:bc=1:break
	next
	if bc=0 then {
		for i=0 to m(jj)-1
			if (c(jj,i)-1)\13=a then is=i:break
		next
	}
	return(is)
endfunc

//----------------------------------------------------------------

func sscom3()
int i,is,a,bc=0
	if b1>100 then a=(b1-100)\13 else if b1>0 then a=(b1-1)\13
	for i=0 to m(jj)-1
		if (c(jj,i)-1)\13=a and p(jj,i)>b1 and p(jj,i)>b2 then {
			is=i:bc=1:break
		}
	next
	if bc=0 then {
		for i=0 to m(jj)-1
			if (c(jj,i)-1)\13=a then is=i:break
		next
	}
	return(is)
endfunc

//----------------------------------------------------------------

func sscom4()
int i,is,a,bc=0
	if b1>100 then a=(b1-100)\13 else if b1>0 then a=(b1-1)\13
	for i=0 to m(jj)-1
		if (c(jj,i)-1)\13=a and p(jj,i)>b1 and p(jj,i)>b2 and p(jj,i)>b3 then {
			is=i:bc=1:break
		}
	next
	if bc=0 then {
		for i=0 to m(jj)-1
			if (c(jj,i)-1)\13=a then is=i:break
		next
	}
	return(is)
endfunc

//----------------------------------------------------------------

func cdleft(k)
	int i
	for i=0 to 8-k
		cc(k+i)=cc(k+i+1)
		pp(k+i)=pp(k+i+1)
	next
endfunc

//----------------------------------------------------------------

func int sel(title$;str,m,n)
str mm,nn
	switch m
		case 1:mm=localizedString("必　要","Necessary"):break
		case 2:mm=localizedString("Ｏ　Ｋ","Yes")
	endswitch
	switch n
		case 1:nn=localizedString("不　要","Unnecessary"):break
		case 2:nn=localizedString("やめる","No")
	endswitch

	dim str menues(1)
	menues(0)=mm
	menues(1)=nn
	int s
	switch selectMenu(title$,menues)
		case 0
			s=1
			break
		case 1
			s=2
			break
	endswitch
	cwait(40)
	return(s)
endfunc

//----------------------------------------------------------------

func click()
	if isLocalizeJapan() then {
		symbol16X68(176,48,"よければ画面を"	 ,1,15,FONT,FNTSZ)
		symbol16X68(208,84,"タップ"			 ,1,15,FONT,FNTSZ)
	} else {
		symbol16X68(172,48,"Please tap"		 ,1,15,FONT,FNTSZ)
		symbol16X68(172,84,"when you are ready",1,15,FONT,FNTSZ)
	}

	while getTouchStatus()=TOUCH_NONE
	endwhile
	//
	er_upms()
endfunc

//----------------------------------------------------------------

func mkba()
int i
	apage(GPAGE2)
	fill16X68(161,145,391,351, 8)
	fill16X68(184,164,368,200,15)
	fill16X68(393,145,509,319, 8)
	fill16X68(393,321,509,509, 8)
	fill16X68(161,353,391,383, 6)
	symbol16X68(396,164,localizedString("ストックカード","Stock Card")	,1,15,FONT,FNTSZ)
	symbol16X68(412,336,localizedString("捨　て　札","Discard")	  		,1,15,FONT,FNTSZ)
	for i=0 to 2:symbol16X68(8,i*100+112 ,nam(i),1,15,FONT,FNTSZ):next
	symbol16X68(8,428,nam(3),1,15,FONT,FNTSZ)
	for i=0 to 3:symbol16X68(i*55+177,316,nam(i),1,15,FONT,FNTSZ):next
	apage(GPAGE1)
endfunc

//----------------------------------------------------------------

func dsban(j)
	er_ms()
	if isLocalizeJapan() then {
		symbol16X68(212,172,nam(j) +"の番" 	,1.5,1,FONT,FNTSZ)
	} else {
		symbol16X68(212,172,nams(j)+" turn"	,1.5,1,FONT,FNTSZ)
	}
endfunc

//----------------------------------------------------------------

func kachi(jj)
	er_ms()
	symbol16X68(200,171,nam(jj)+localizedString("の勝ち"," win"),1.5,5,FONT,FNTSZ)
endfunc

//----------------------------------------------------------------

func dame()
	er_upms()
	symbol16X68(180,60,localizedString("出せません","Can't throw"),1,5,FONT,FNTSZ)
	a_play(snd(3))
endfunc

//----------------------------------------------------------------

func bacd(j,i)
	cardPut(j*55+169,216,c(j,i),NO)
	a_play(snd(1))
endfunc

//----------------------------------------------------------------
/* プレイヤ・カードの表示

func plcd()
int i
	fill16X68(47,400,386,496,0)
	if m(3)>6 then {
		for i=0 to m(3)-1
			cardPut(i*36+48,400,c(3,i),NO)
			 line16X68(i*36+47,400,i*36+47,496,10)
			 a_play(snd(1))
		next
	} else {
		for i=0 to m(3)-1
			cardPut(i*58+48,400,c(3,i),NO)
		next
	}
	  fill16X68(16,453,24,469,0)
	symbol16X68(16,453,str$(m(3)),1,15,FONT,FNTSZ)
endfunc

//----------------------------------------------------------------
/* comカードの表示

func comcd(j)
int i
	fill16X68(47,j*100+84,153,j*100+180,0)
	for i=0 to m(j)-1
	  cardPut(i*7+48,j*100+84,0,NO)
	   line16X68(i*7+47,j*100+84,i*7+47,j*100+180,10)
		a_play(snd(1))
	next
	  fill16X68(16,j*100+136,24,j*100+152,0)
	symbol16X68(16,j*100+136,str$(m(j)),1,15,FONT,FNTSZ)
endfunc

//----------------------------------------------------------------
/* comカード1枚追加表示

func pluscom(j,m)
	cardPut((m-1)*7+48,j*100+84,0,NO)
	 line16X68((m-1)*7+47,j*100+84,(m-1)*7+47,j*100+180,10)
	a_play(snd(1))
	  fill16X68(16,j*100+136,24,j*100+152,0)
	symbol16X68(16,j*100+136,str$(m),1,15,FONT,FNTSZ)
endfunc

//----------------------------------------------------------------
/* ストックカードの表示

func stcd()
int i
	for i=0 to ms-1
		cardPut(i*4+399,192,0,NO)
		 line16X68(i*4+398,192,i*4+398,288,8)
		a_play(snd(1))
	next
	  fill16X68(444,292,460,308,0)
	symbol16X68(444,292,str$(ms),1,15,FONT,FNTSZ)
endfunc

//----------------------------------------------------------------
/* ストックカード1枚減らす表示

func decst(i)
	fill16X68(i*4+398,192,i*4+447,288,0)
	if i>0 then {
		cardPut(i*4+395,192,0,NO)
		 line16X68(i*4+394,192,i*4+394,288,8)
	}
	a_play(snd(1))
	  fill16X68(444,292,460,308,0)
	symbol16X68(444,292,str$(i),1,15,FONT,FNTSZ)
endfunc

//----------------------------------------------------------------
/* 捨て札の表示

func sutecd()
int i,x,y
	for i=0 to 3
		if sute(i)>100 then sute(i)=sute(i)-100
		if sute(i)=13 or sute(i)=26 or sute(i)=39 or sute(i)=52 then {
			sute(i)=sute(i)-12
		} else {
			sute(i)=sute(i)+1
		}
		x=rnd()*56+400
///		x=400+CARD_WX/2*i
		y=rnd()*44+364
		cardPut(x,y,sute(i),NO)
		box16X68(x-1,y-1,x+47,y+95,8)
		a_play(snd(1))
	next
endfunc

//----------------------------------------------------------------

func cwait(t)
/* X68 10MHz n=500で42秒
	wait((42.0/500.0/5.0)*t)
//	int i
//	for i=0 to t*100:next
endfunc

//----------------------------------------------------------------

func er_upms()
	fill16X68(161,3,319,143,0)
endfunc

//----------------------------------------------------------------

func er_ms()
	fill16X68(184,164,368,200,15)
endfunc

//----------------------------------------------------------------

func rule()
	// グラフィックを徐々に暗くする
	int pg
	float al=1.0
	repeat
		al=al-0.1
		for pg=GPAGE0 to GPAGE3
			apage(pg)
			gBackgroundAlpha(al)
			wait(0.02)
		next
	until al<0.4
	//
	if isLocalizeJapan() then {
	printgs(196,160,"ル ー ル")
	printgs(60,182,"1：カードの強さはA,K,Q,J,,,4,3,2の順"					)
	printgs(60,200,"2：貴方に最後に配られたカードのスートが切り札"			)
	printgs(60,218,"3：各自１枚づつ最初と同じスーツを出さねばなりません"	)
	printgs(60,236,"4：持ってなければ切り札又は他のカードを出します"		)
	printgs(60,254,"5：最強の切札又は台札と同じスートの最強のカード"		)
	printgs(92,271,"を出した人が勝ち"										)
	printgs(60,289,"6：勝った人はストックから１枚取り手札に加えます。また"	)
	printgs(92,306,"次は最初に台札を出します"								)
	printgs(60,324,"7：手札が無くなった人は負け、もうプレー出来ません"		)
	printgs(60,342,"8：全員が脱落した後まだカードを持っている人が勝ち"		)
	printgs(60,360,"9：最後に持っているカード１枚に付き１００点、他は０点"	)
	} else {
	printgs(196,160,"Rule")
	printgs(60,182,"1 : The card strength order is A,K,Q,j ...4,3,2."		)
	printgs(60,200,"2 : The last card dealt for you will be master card."	)
	printgs(60,218,"3 : You must throw a same suit card as first."			)
	printgs(60,236,"4 : If you do not have same card, you throw master or other card."	)
	printgs(60,254,"5 : If you throw the strongest master card or the same suit strongest card, you will win."	)
	printgs(60,289,"6 : The winner can get a card from stock. Or can throw card first at next turn."			)
	printgs(60,324,"7 : When you have no card, you will lose and do not play any more."		)
	printgs(60,342,"8 : You will win when other person are lose."		)
	printgs(60,360,"9 : You get 100 points per card. Others get 0 point.")
	}
	// テキストを徐々に明るくする
	al=0.0
	repeat
		al=al+0.1
		tBackgroundAlpha(al)
		wait(0.02)
	until al>=1.0
	
	// 前のタッチが離されるのを待つ
	while getTouchStatus()<>TOUCH_NONE:endwhile
	// タッチされるのを待つ
	repeat
	until getTouchStatus()<>TOUCH_NONE
//	hitKey(NO)
	cls()
	for pg=GPAGE0 to GPAGE3
		apage(pg)
		gBackgroundAlpha(1)
	next
	apage(GPAGE1)
endfunc

func printgs(x;int,y;int,mes;str)
	locate(x,y):// グラフィック座標モード
	print mes
endfunc

//****************************************************************
// 補助関数
//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
